<HTML>
<HEAD>
<TITLE>HEPiX X11 Scripts - Tools</TITLE>
<!-- Changed by: Lionel Cons,  8-Jan-1997 -->
</HEAD>
<BODY>

<H1>HEPiX X11 Scripts - Tools</H1>

<P> This page describes the different tools that are used by the <A HREF=".">HEPiX X11 scripts</A>.

<P> Index: <A HREF="#apply_policy">apply_policy</A> - <A HREF="#dump_shell_env">dump_shell_env</A> - <A HREF="#is_hepix">is_hepix</A> - <A HREF="#local-client">local-client</A> - <A HREF="#prepare-wmrc">prepare-wmrc</A> - <A HREF="#quota-warn">quota-warn</A> - <A HREF="#utmp_update">utmp_update</A> - <A HREF="#xinfo">xinfo</A> - <A HREF="#xkillwm">xkillwm</A> - <A HREF="#xmessage">xmessage</A> - <A HREF="#xsecure">xsecure</A> - <A HREF="#xsession-fake">xsession-fake</A> - <A HREF="#xsetfp">xsetfp</A>

<P> <HR> <P>

<P> Note: all these tools can be found by default under
<CODE>/usr/local/lib/hepix/X11/tools</CODE> except:
<UL>
<LI> <A HREF="./tools.html#apply_policy"><CODE>apply_policy</CODE></A> and <A HREF="./tools.html#dump_shell_env"><CODE>dump_shell_env</CODE></A> used internally by the X session 
     and located under <CODE>/usr/local/lib/hepix/X11/hep</CODE>
<LI> <A HREF="./tools.html#is_hepix"><CODE>is_hepix</CODE></A> and <A HREF="./tools.html#utmp_update"><CODE>utmp_update</CODE></A> used only by the <CODE>xdm</CODE> wrappers
     and located under <CODE>/usr/local/lib/hepix/X11/xdm</CODE>
</UL>

<A NAME="apply_policy"><H3><CODE>apply_policy</CODE></H3></A>

<P> This checks all the settings (usually <A
HREF="vars.html#switches">major switches</A>) in order to detect
errors (e.g. window manager not available) and apply the policy. The
exact behaviour is described in more details <A
HREF="policy.html">elsewhere</A>.

<A NAME="dump_shell_env"><H3><CODE>dump_shell_env</CODE></H3></A>

<P> This starts a login shell for the user in order to dump all the
environment variables to detect all the settings made in the "profile"
files: <CODE>.login</CODE>, <CODE>.profile</CODE>,
<CODE>.tcshrc</CODE>...

<A NAME="is_hepix"><H3><CODE>is_hepix</CODE></H3></A>

<P> This tests if a user should run or not the <A HREF="./..">HEPiX scripts</A>. It is meant to be
used both by the shells and the X11 parts of the <A HREF="./..">HEPiX scripts</A>. The algorithm
is:

<UL>
<LI> if the user name is root then no
<LI> if the user id is &lt;= 100 then no
<LI> if the user appears in the exception list
     (by default <CODE>/etc/hepix/list-</CODE>) then no
<LI> otherwise yes
</UL>

<A NAME="local-client"><H3><CODE>local-client</CODE></H3></A>

<P> This should start the given client with optional arguments and
hang until it finishes (i.e. it can be used as a last client). With
<CODE>-check</CODE>, it tells if the client can be used (return code
being 0) or why it can't be used (message on stdout).

<P> It should work with X terminals and PCs with X emulation with the
help of auxiliary programs like <CODE>ncdrunwm</CODE>, to be bundled
with the <A HREF=".">HEPiX X11 scripts</A>...

<A NAME="prepare-wmrc"><H3><CODE>prepare-wmrc</CODE></H3></A>

<P> This generates a configuration file for the selected window manager,
with a name similar to <A HREF="./files.html#$HOME/.hepix/wm/generated_wmrc"><CODE>$HOME/.hepix/wm/generated_wmrc</CODE></A>.

<P> This command is usually called indirectly when the user sets <A HREF="./vars.html#HX_WM"><CODE>$HX_WM</CODE></A>
to something like <SAMP>"foowm -prepare"</SAMP>.

<P> The only window managers currently supported are <CODE>fvwm</CODE>
and <CODE>fvwm2</CODE>.

<A NAME="quota-warn"><H3><CODE>quota-warn</CODE></H3></A>

<P> This is a copy of the program that comes with the <A HREF="./../shells">HEPiX shells scripts</A>.
It is described <A HREF="../shells/tools.html#quota-warn">elsewhere</A>.

<A NAME="utmp_update"><H3><CODE>utmp_update</CODE></H3></A>

<P> This updates the <CODE>/etc/utmp</CODE> file by creating or
deleting an entry for a given user and display. It is meant to be used
only for X sessions.

<A NAME="xinfo"><H3><CODE>xinfo</CODE></H3></A>

<P> This collects various pieces of information about the X
environment and can be seen as a merge of `<CODE>xdpyinfo</CODE>',
`<CODE>xrdb -symbols</CODE>' and `<CODE>xprop -root</CODE>'.

<P> Its output can be <CODE>eval</CODE>'ed by a shell script to
provide the informational variables described <A
HREF="vars.html#info">elsewhere</A>.

<A NAME="xkillwm"><H3><CODE>xkillwm</CODE></H3></A>

<P> This detects the presence of a window manager and optionaly kills
it by destroying some of its windows with <CODE>XKillClient</CODE>.

<A NAME="xmessage"><H3><CODE>xmessage</CODE></H3></A>

<P> This is the X client from the X consortium (X11R6.1 distribution)
with a small patch to make it disappear automatically when a new X
client appears on the screen if the option <CODE>-shy</CODE> is used.

<P> There are also two "shortcuts" (scripts):
<CODE>xmessage-ack</CODE> (display a message that must be acknowledged) and
<CODE>xmessage-tmp</CODE> (display a temporary message).

<A NAME="xsecure"><H3><CODE>xsecure</CODE></H3></A>

<P> This "secures" the X server by:
<UL>
<LI> enabling the X access control (like <CODE>xhost -</CODE>)
<LI> emptying the X access control list
<LI> checking if the authorisation mechanism (<CODE>xauth</CODE>) is used
<LI> if it's not used, adding the local host name to the X access control list
</UL>

<A NAME="xsession-fake"><H3><CODE>xsession-fake</CODE></H3></A>

<P> Simply starts a "fake" HEPiX X session by calling
<CODE>/usr/local/lib/hepix/X11/hep/HEP_Xsession -fake</CODE>.

<A NAME="xsetfp"><H3><CODE>xsetfp</CODE></H3></A>

<P> This adds an entry to the X server font path (like `<CODE>xset
fp+</CODE>') but:
<UL>
<LI> it checks if the entry is already in the font path
     (when comparing font servers, it only checks the port numbers used)
<LI> if the modification fails, it sleeps and retries
<LI> it prepends the entry if it starts with an minus sign (<SAMP>`-'</SAMP>)
<LI> it can be given several arguments, the return code is zero if at least
     one of the font path entry is in the X server font path or has been
     added successfully
</UL>

<P> <HR> <P>

<ADDRESS>
<A HREF="http://wwwinfo.cern.ch/~cons">Lionel Cons</A>,  8-Jan-1997
</ADDRESS>

</BODY>
</HTML>

